function   Tf=FFTsynchrosqueezing_v2(S,N,fs,fr)
% Input
% S: Fourier-transformed version of signal x obtained using stft(x,N)
% N: Window size, used also before calling this function to Fourier transform signal x in S; S=stft(x,N)
% fs: Sampling frequency
% fr: User-specified frequency resolution.
%
% Output
% Tf: Time-frequency representaion with the size of nfreq*m, where nfreq is the number of frequency bins determined through fr, m data length
%%

[n,m]=size(S);
M=length(S);

for i=1:n
        IF(i,:)=diff(unwrap(phase(S(i,:))))/(2*pi);  %estimate the instantaneous frequency, IF=d(IP)/dt, IP is the instantaneous phase
end

for i=1:n
    IF(i,end+1)=IF(i,end);
end


% freq = 2*pi*linspace(0,0.5,floor(m/2)+1);
freq = 2*pi*linspace(0,0.5,(fs/2)/fr); %% Apit edited freq. resolution on 270916. Now it is independent of number of samples but is specified by the user.
%freq = 2*pi*linspace(0,0.5,floor(2002/2)+1);
nfreq = length(freq);


freq=freq/(2*pi);
df = freq(2) - freq(1);
Tf = zeros(nfreq,m);

k=1:N/2;

%Squeezing
for j=1:n
    for m=1:M
        if IF(j,m)<0  
        else
             l = ceil(IF(j,m)/df+0.5);

             if l>0 && l<=nfreq  && isfinite(l)  &&  abs(S(j,m))>0  
                  Tf(l,m)=Tf(l,m)+(S(j,m)*exp(1i*pi*(k(j)-1)));
             end
        end
    end
end

Tf=Tf/(N/2);
thresh=0.03;

for j=1:n
    for m=1:M
        if abs(Tf(l,m))>thresh
            Tf(l,m)=Tf(l,m);
        else
            Tf(l,m)=0;
        end
    end
end
       
         


